#include <math.h>
#include <time.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <values.h>
#include <string.h>
#include <ctype.h>
#include <dir.h>
#include <process.h>
#include <graphics.h>
#include "common.h"

extern void BadExit( const char* Msg);

/* writes ContMsg and waits for keyboard tap */
void ContMsgRoutine( void)
{
	printf( "%s", ContMsg);
	while( True)
		if( KeyStroke)
			break;
	getch();
}

void BadMsgExit( const char* Msg)
{
	clrscr();
	gotoxy( 1, 1);
	printf( "Error: %s.\n", Msg);
	ContMsgRoutine();
	_exit( 1);
}

void InitCommonVars( void)
{
	headkeys = (int far*) HeadKeysMemoryLocation;
	tailkeys = (int far*) TailKeysMemoryLocation;

	/* all internal values kept in radians:
	1 revolution = 2 Pi Radians = 360 Degrees = 24 Hours = 1440 Minutes */
	OneRev = 2*M_PI;
	HalfRev = OneRev/2;
	QtrRev = OneRev/4;
	RadToDeg = 360./OneRev;
	RadToArcmin = 60.*RadToDeg;
	RadToArcsec = 60.*RadToArcmin;
	RadToTenthsArcsec = 10.*RadToArcsec;
	RadToHr = 24./OneRev; 
	RadToMin = 60.*RadToHr; 
	RadToSec = 60.*RadToMin; 
	RadToHundSec = 100.*RadToSec; 
	DaysToHr = 24.; 
	DaysToMin = 60.*DaysToHr;
	DaysToSec = 60.*DaysToMin; 
	ArcsecPerRev = 1296000.; 
	ArcsecPerDeg = 3600.;

	SidRate = 1.002737909; 

	/* ~18.2065 clock ticks per second */
	ClockTicksDay = 1573040.;
	ClockTicksSec = ClockTicksDay/DaysToSec;
	ClockTicksMin = ClockTicksDay/DaysToMin;
	ClockTicksHr = ClockTicksDay/DaysToHr;
	RadToClockTick = ClockTicksDay/OneRev;
}

int GetNumStr( char NumStr[], int NumChars)
{
	int IxA, IxB;

	for( IxA = 0; IxA < NumChars; IxA++)
		NumStr[IxA] = ' ';
	NumStr[NumChars] = '\0';
	printf( "[");
	VidMemXY.X = wherex();
	VidMemXY.Y = wherey();
	gotoxy( VidMemXY.X + NumChars, VidMemXY.Y);
	printf( "]");
	gotoxy( VidMemXY.X, VidMemXY.Y);
	IxA = 0;
	Response = getch();
	while( Response != Return && Response != Esc)
	{
		if( IxA && (Response == Backspace || Response == LeftCursor))
			NumStr[--IxA] = ' ';
		else if( IxA < NumChars && ((Response >= '0' && Response <= '9')
		|| Response == '.' || Response == '+' || Response == '-'))
				NumStr[IxA++] = Response;
		for( IxB = 0; IxB < IxA; IxB++)
		{
			gotoxy( VidMemXY.X + IxB, VidMemXY.Y);
			printf( "%c", NumStr[IxB]);
		}
		for( IxB = IxA; IxB < NumChars; IxB++)
		{
			gotoxy( VidMemXY.X + IxB, VidMemXY.Y);
			printf( " ");
		}
		gotoxy( VidMemXY.X + IxA, VidMemXY.Y);
		Response = getch();
	}
	if( Response == Return)
		return True;
	else
		return False;
}

int GetInt( int* Num)
{
	char NumStr[MaxCharsInt+1];

	if( GetNumStr( NumStr, MaxCharsInt))
	{
		*Num = atoi( NumStr);
		return True;
	}
	else
		return False;
}

int GetDouble( double* Num)
{
	char NumStr[MaxCharsDbl+1];

	if( GetNumStr( NumStr, MaxCharsDbl))
	{
		*Num = atof( NumStr);
		return True;
	}
	else
		return False;
}

void ReadDouble( FILE* File, double* V)
{
	if( !feof( File))
	{
		fscanf( File, "%s", Value);
		*V = atof( Value);
	}
}

void ReadFlag( FILE* File, Flag* V)
{
	if( !feof( File))
	{
		fscanf( File, "%s", Value);
		*V = (Flag) atoi( Value);
	}
}

void ReadByte( FILE* File, Byte* V)
{
	if( !feof( File))
	{
		fscanf( File, "%s", Value);
		*V = (Byte) atoi( Value);
	}
}

void ReadInt( FILE* File, int* V)
{
	if( !feof( File))
	{
		fscanf( File, "%s", Value);
		*V = atoi( Value);
	}
}

void ReadUnsigned( FILE* File, unsigned* V)
{
	if( !feof( File))
	{
		fscanf( File, "%s", Value);
		*V = (unsigned) atoi( Value);
	}
}

void ReadLong( FILE* File, long* V)
{
	if( !feof( File))
	{
		fscanf( File, "%s", Value);
		*V = atol( Value);
	}
}

void FReadChar( FILE* File, char* V)
{
	if( !feof( File))
		fread( V, 1, 1, File);
	else
		*V = ' ';
}

void FReadToNewLine( FILE* File)
{
	char Dummy = ' ';

	while( !feof( File) && Dummy != '\n')
			fread( &Dummy, 1, 1, File);
}

void FReadToChar( FILE* File, const char V)
{
	char Dummy = ' ';

	while( !feof( File) && Dummy != V)
			fread( &Dummy, 1, 1, File);
}

void ReadString( FILE* File, char* Name)
{
	char C = '\0';
	int Ix;

	/* read past white space */
	do
	{
		FReadChar( File, &C);
	}while( C == ' ');
	Name[0] = C;
	/* read until newline */
	Ix = 0;
	while( Ix < ObjectNameSize && Name[Ix++] != '\n')
		fread( &Name[Ix], 1, 1, File);
	Ix--;
	/* fill out name */
	while( Ix < ObjectNameSize)
		Name[Ix++] = '\0';
}

/* returns next increment count above highest numbered file name,
ie, if name00.txt and name02.txt exist, then 3 is returned,
if no file exists, then returns 0 */
int FindNextIncrFilename( char* Name, char* Extension)
{
	char Fname[13];
	int value;
	int highestvalue = -1;

	strcpy( Fname, Name);
	strcat( Fname, "??.");
	strcat( Fname, Extension);

	FindFirst = True;
	FoundFile = True;

	while( FoundFile)
	{
		if( FindFirst)
		{
			FindFirst = False;
			/* returns 0 if successful */
			FoundFile = !findfirst( Fname, &Ffblk, 0);
		}
		else
			FoundFile = !findnext( &Ffblk);

		if( FoundFile)
			if( Ffblk.ff_name[strlen( Name)] >= '0' &&
			Ffblk.ff_name[strlen( Name)] <= '9' &&
			Ffblk.ff_name[strlen( Name)+1] >= '0' &&
			Ffblk.ff_name[strlen( Name)+1] <= '9')
			{
				value = (Ffblk.ff_name[strlen( Name)] - '0') * 10 +
				Ffblk.ff_name[strlen( Name)+1] - '0';

				if( value > highestvalue)
					highestvalue = value;
			}
	}
	return highestvalue + 1;
}

/* serial port... */

/* polled transmit, interrupt driven receive */

void interrupt Ser1ISR( void)
{
	Ser1Buf[Ser1BufWrIx++] = inportb( Com1Base);
	/* SerBufEnd must be 2^n - 1 for this to work:
	very much faster than comparing and setting to zero */
	Ser1BufWrIx &= SerBufEnd;
	Ser1Count++;
	/* enable PIC to service this interrupt again */
	outportb( PIC_EOI_ADDR, EOI);
}

void interrupt Ser2ISR( void)
{
	Ser2Buf[Ser2BufWrIx++] = inportb( Com2Base);
	/* SerBufEnd must be 2^n - 1 for this to work:
	very much faster than comparing and setting to zero */
	Ser2BufWrIx &= SerBufEnd;
	Ser2Count++;
	/* enable PIC to service this interrupt again */
	outportb( PIC_EOI_ADDR, EOI);
}

void InitSerial( const int ComPort, const int BaudRate, const int Parity,
const int DataBits, const int StopBits)
{
	unsigned R;

	if( ComPort==1)
	{
		SerialBase = Com1Base;
		/* save current serial interrupt routine */
		OldSer1IntVec = getvect( Com1Int);
		/* set new serial interrupt routine */
		setvect( Com1Int, Ser1ISR);
		/* set PIC by zeroing relevant bit */
		outportb( IntMaskReg, inportb( IntMaskReg) & (~Int4Mask));
		InitRingBuffer( ComPort);
	}
	else
		if( ComPort==2)
		{
			SerialBase = Com2Base;
			/* save current serial interrupt routine */
			OldSer2IntVec = getvect( Com2Int);
			/* set new serial interrupt routine */
			setvect( Com2Int, Ser2ISR);
			/* set PIC by zeroing relevant bit */
			outportb( IntMaskReg, inportb( IntMaskReg) & (~Int3Mask));
			InitRingBuffer( ComPort);
		}

	if( ComPort)
	{
		/* set UART */
		R = (unsigned) (115200L / BaudRate);
		/* loopback required by early 8250s */
		outportb( SerialBase + MCR, 0x10);
		/* set DLAB = 1, if divisor latch access bit == 1, then ports 0, 1 used
		as baud rate divisor, otherwise ports 0, 1 used to receive/transmit */
		outportb( SerialBase + LCR, 0x80);
		/* load rate divisor LSB */
		outportb( SerialBase, R & 0xFF);
		/* load divisor MSB */
		outportb( SerialBase + IER, (R>>8) & 0xFF);
		/* data bits: 1st two bits used to set DataBits; DataBits can range from
		5 (bits value of 0) to 8 (bits value of 3) */
		/* stop bits: uses 3rd bit: if 2 StopBits, then set to 1, otherwise 0 */
		/* parity bits: uses 4th to 6th bits */
		/* 7th bit is break bit, 8th bit is DLAB */
		/* set DLAB back to zero, set DataBits, StopBits */
		outportb( SerialBase + LCR,
		((DataBits-5) & 3) | Parity | (StopBits==2? 4:0));
		/* turn on DTR, RTS (set to 0 to turn off MCR) */
		outportb( SerialBase + MCR, MCR_DTR | MCR_RTS);

		/* enable UART */
		/* clear out any stray char */
		inportb( SerialBase);
		/* read LSR to clear it */
		inportb( SerialBase + LSR);
		/* ditto MSR */
		inportb( SerialBase + MSR);
		/* enable 8250 Rx interrupt only */
		outportb( SerialBase + IER, 1);
		/* turn on RTS, DTR, OUT2 */
		outportb( SerialBase + MCR, 0x0B);
	}
}

void CloseSerial( const int ComPort)
{
	Byte B;

	if( ComPort==1)
	{
		/* clear out any remaining chars to read */
		while( ReadSerial( ComPort, &B))
			;
		SerialBase = Com1Base;
		/* OUT2 off to disable int */
		outportb( SerialBase + MCR, inportb( SerialBase + MCR) ^ 0x08);
		/* reset PIC, set the relevant bit */
		outportb( IntMaskReg, inportb( IntMaskReg) | Int4Mask);
		/* restore original interrupt vector */
		setvect( Com1Int, OldSer1IntVec);
	}
	else
		if( ComPort==2)
		{
			/* clear out any remaining chars to read */
			while( ReadSerial( ComPort, &B))
				;
			SerialBase = Com2Base;
			/* OUT2 off to disable int */
			outportb( SerialBase + MCR, inportb( SerialBase + MCR) ^ 0x08);
			/* reset PIC, set the relevant bit */
			outportb( IntMaskReg, inportb( IntMaskReg) | Int3Mask);
			/* restore original interrupt vector */
			setvect( Com2Int, OldSer2IntVec);
		}
}

void InitRingBuffer( const int ComPort)
{
	if( ComPort==1)
	{
		disable();
		Ser1BufRdIx = Ser1BufWrIx = 0;
		Ser1Count = 0;
		enable();
	}
	else
		if( ComPort==2)
		{
		disable();
		Ser2BufRdIx = Ser2BufWrIx = 0;
		Ser2Count = 0;
		enable();
	}
}

Flag ReadSerial( const int ComPort, Byte* B)
{
	if( ComPort==1)
	{
		SerialBase = Com1Base;
		if( Ser1BufRdIx != Ser1BufWrIx)
		{
			disable();
			*B = Ser1Buf[Ser1BufRdIx++];
			/* SerBufEnd must be 2^n - 1 for this to work:
			very much faster than comparing and setting to zero */
			Ser1BufRdIx &= SerBufEnd;
			Ser1Count--;
			enable();
			return True;
		}
		else
			return False;
	}
	else
		if( ComPort==2)
		{
			SerialBase = Com2Base;
			if( Ser2BufRdIx != Ser2BufWrIx)
			{
				disable();
				*B = Ser2Buf[Ser2BufRdIx++];
				/* SerBufEnd must be 2^n - 1 for this to work:
				very much faster than comparing and setting to zero */
				Ser2BufRdIx &= SerBufEnd;
				Ser2Count--;
				enable();
				return True;
			}
			else
				return False;
		}
		else
			return False;
}

Flag WriteSerial( const int ComPort, Byte B)
{
	long Count = 0;
	const long MaxCount = 10000L;

	if( ComPort==1)
		SerialBase = Com1Base;
	else
		if( ComPort==2)
			SerialBase = Com2Base;
		else
			SerialBase = 0;

	if( SerialBase)
	{
		/* if bit 5 is set, then ready for transmit */
		while( !(inportb( SerialBase + LSR) & 0x20) && Count++ < MaxCount)
			;
		if( Count < MaxCount)
		{
			outportb( SerialBase, B);
			return True;
		}
		else
			return False;
	}
	else
   	return False;
}

Flag WriteSerialString( const int ComPort, char C[], const int CharCount)
{
	int Ix;
	Flag SerialOK = True;

	for( Ix = 0; Ix < CharCount && SerialOK; Ix++)
	{
		if( WriteSerial( ComPort, C[Ix]))
			/* 9600 bps ~= 1000 cps (char/sec) */
			delay( 1);
		else
			SerialOK = False;
	}
	return SerialOK;
}

void TestSerial( const int ComPort)
{
	Flag QuitFlag = No;
	Byte B;

	printf( "\n\n\nTest of serial port on com %1d (9600,8,n,1):\n", ComPort);
	printf( "'x' to quit\n\n");

	while( !QuitFlag)
	{
		if( ReadSerial( ComPort, &B))
			printf( "%c", B);

		if( KeyStroke)
		{
			B = getch();
			if( B == 'x' || B == 'X')
				QuitFlag = Yes;
			else
				if( WriteSerial( ComPort, B))
					printf( "%c", B);
		}
	}
	NewLine;
	ContMsgRoutine();
}

/* video... courtesy Dale Eason */

/* Speed gain by using direct video memory is considerable */

/* The PC's screen in text mode consists of 25 rows and 80 columns.
The first row and column is addressed as location (0, 0), and the last
row and column as location (24, 79).  This is swapped from the goto( x, y)
function.  Each screen location actually consists of two components: a
character and an attribute.  To support this arragement, a structure called
'Texel' is used to represent the character and the attribute written to a
screen location.

To write a character and its attribute to a screen location, a screen
pointer is used: ScreenArea far *ScreenPtr;

This screen pointer can be set to one of two values: B000:000h for a
monochrome display adapter and B800:000h for a graphics adapter.
To determine which adapter is installed, use a call to the ROM-BIOS
(interrupt 0x10).

Once ScreenPtr has been assigned a screen address, a character and an
attribute can be written to the screen.  But first, to simplify the notation,
we've defined the macro constant: #define Screen (*ScreenPtr)

Putting all this together, we can write the character A with normal video
to row 6, column 11 using:

	  Screen[5][10].Ch = 'A';
	  Screen[5][10].Attr = 7;

We can also use this notation to read a character and its attributes at
a specific screen location:

	 Ch = Screen[5][10].Ch;
	 Attr = Screen[5][10].Attr; */

void InitVideo( const Flag DisplayOpeningMsgs)
{
	Regs.h.ah = 15;
	int86( 0x10, &Regs, &Regs);
	if( Regs.h.al == 7)
		MemSeg = 0xB000;
	else
		MemSeg = 0xB800;
	MemOff = Regs.h.bh * (unsigned) 0x1000;
	ScreenPtr = (ScreenArea far*) (( (long) MemSeg << 16) | (long) MemOff);

	if( DisplayOpeningMsgs)
		if( MemSeg == 0xB000)
			printf( "\nvideo mode: monochrome");
		else
			printf( "\nvideo mode: graphics adaptor");
}

/* write a character to the screen at Y and X */
void WriteCharToScreen( const char Char)
{

	Screen[VidMemXY.Y][VidMemXY.X].Ch = Char;
	Screen[VidMemXY.Y][VidMemXY.X].Attr = TextAttr;

	/*
	textattr( TextAttr);
	gotoxy( VidMemXY.X+1, VidMemXY.Y+1);
	cprintf( "%c", Char);
	*/
}

/* write a character string using StrBuf to the screen at Y and X;
VidMemXY.X is changed, VidMemXY.Y is not */
void WriteStrBufToScreen( void)
{
	char* StrPtr = StrBuf;

	while( *StrPtr)
	{
		Screen[VidMemXY.Y][VidMemXY.X].Attr = TextAttr;
		Screen[VidMemXY.Y][VidMemXY.X++].Ch = *StrPtr++;
	}

	/*
	textattr( TextAttr);
	gotoxy( VidMemXY.X+1, VidMemXY.Y+1);
	while( *StrPtr)
		cprintf( "%c", *StrPtr++);
	*/
}

void TestVideo( void)
{
	struct XY HoldXY;
	int i;
	const maxi = MAXINT - 1;
	time_t t;
	time_t start;

	clrscr();
	printf( "\n\n\nTest of video code...\n");
	printf( "segment %u   offset %d\n\n", MemSeg, MemOff);

	directvideo = 1;
	HoldXY.X = wherex();
	HoldXY.Y = wherey();
	printf( "To display ");

	/* my turn */
	start = time( NULL);
	for( i = 1; i <= maxi; i++)
	{
		/* my direct video */
		sprintf( StrBuf, "%6d", i);
		VidMemXY.X = HoldXY.X + 11;
		VidMemXY.Y = HoldXY.Y - 1;
		WriteStrBufToScreen();
	}
	t = time( NULL);
	gotoxy( HoldXY.X + 20, HoldXY.Y);
	printf( " times");
	gotoxy( HoldXY.X, HoldXY.Y + 1);
	printf( "Took my code %d seconds", t - start);

	/* Borland's turn */
	start = time( NULL);
	for( i = 1; i <= maxi; i++)
	{
		gotoxy( HoldXY.X + 12, HoldXY.Y);
		printf( "%6d", i);
	}
	t = time( NULL);
	gotoxy( HoldXY.X, HoldXY.Y + 2);
	printf( "Took Borland with direct video %d seconds", t - start);

	/* direct video off */
	directvideo = 0;
	start = time( NULL);
	for( i = 1; i <= maxi; i++)
	{
		gotoxy( HoldXY.X + 12, HoldXY.Y);
		printf( "%6d", i);
	}
	t = time( NULL);
	gotoxy( HoldXY.X, HoldXY.Y + 3);
	printf( "Borland w/o direct video %d seconds", t - start);

	NewLine;
	ContMsgRoutine();
}

/* CMOS clock used to reset DOS clock when DOS clock has been disturbed */

int UpdateInProgress( void)
{
	outportb( CCP, CMOS_Reg_Status_A); 
	return CMOS_RTN & Update_In_Progress; 
}

void DisplayCMOSTimeDate( void)
{
	printf( "%2d:%02d:%02d   (%2d)%2d/%02d/%02d", CMOS_Hr, CMOS_Min, CMOS_Sec,
	Century, CMOS_Yr, CMOS_Mon, CMOS_Day);
}

void SetDOSToCMOS( void)
{
	static int PrevYr, PrevMon, PrevDay;
	disable();
	/* wait until CMOS clock is ready to increment to next second */
	while( !UpdateInProgress())
		;
	/* wait until CMOS clock is finished updating */
	while( UpdateInProgress())
		;
	/* get CMOS values */
	outportb( CCP, CMOS_Reg_BCD_Sec);
	BCD = CMOS_RTN;
	CMOS_Sec = CMOS_DECODE_BCD;
	outportb( CCP, CMOS_Reg_BCD_Min);
	BCD = CMOS_RTN;
	CMOS_Min = CMOS_DECODE_BCD;
	outportb( CCP, CMOS_Reg_BCD_Hr);
	BCD = CMOS_RTN;
	CMOS_Hr = CMOS_DECODE_BCD;
	outportb( CCP, CMOS_Reg_BCD_Day);
	BCD = CMOS_RTN;
	CMOS_Day = CMOS_DECODE_BCD;
	outportb( CCP, CMOS_Reg_BCD_Mon);
	BCD = CMOS_RTN;
	CMOS_Mon = CMOS_DECODE_BCD;
	outportb( CCP, CMOS_Reg_BCD_Yr);
	BCD = CMOS_RTN;
	CMOS_Yr = CMOS_DECODE_BCD;
	if( CMOS_Yr == 0 && PrevYr == 99 && CMOS_Mon == 1 && PrevMon == 12 &&
	CMOS_Day == 1 && PrevDay == 31 && Century == 19)
		Century = 20;
	/* set DOS to CMOS */
	d.da_year = Century * 100 + CMOS_Yr;
	d.da_mon = CMOS_Mon;
	d.da_day = CMOS_Day;
	setdate( &d);
	t.ti_hour = CMOS_Hr;
	t.ti_min = CMOS_Min;
	t.ti_sec = CMOS_Sec;
	t.ti_hund = 0;
	settime( &t);
	PrevYr = CMOS_Yr;
	PrevMon = CMOS_Mon;
	PrevDay = CMOS_Day;
	enable();
}

void SetRealTimeClock( const int hr, const int min, const int sec)
{
	int daylight = 0;

	Regs.h.ah = 3;
	/* hr, min, sec in BCD format */
	BCD = hr;
	Regs.h.ch = ENCODE_BCD;
	BCD = min;
	Regs.h.cl = ENCODE_BCD;
	BCD = sec;
	Regs.h.dh = ENCODE_BCD;
	Regs.h.dl = daylight;
	int86( 0x1a, &Regs, &Regs);
}

void SetDateofRealTimeClock( const int century, const int year, const int mon,
const int day)
{
	Regs.h.ah = 5;
	/* century (19 or 20), year, mon, day in BCD format */
	BCD = century;
	Regs.h.ch = ENCODE_BCD;
	BCD = year;
	Regs.h.cl = ENCODE_BCD;
	BCD = mon;
	Regs.h.dh = ENCODE_BCD;
	BCD = day;
	Regs.h.dl = ENCODE_BCD;
	int86( 0x1a, &Regs, &Regs);
}

/* astronomical times... */

/* Sidereal time algorithm: at program start, determine sidereal time based
on date, time and longitude, and read bios clock tick count;
then repeatedly read the new bios clock tick count, calculate # of ticks
since program start, calculate the sidereal time increment based on tick
count, and add to program start sidereal time to find the new sidereal time */

void InitTimes( const Flag DisplayOpeningMsgs, const int Tz, const int DST,
double LongitudeDeg)
{
	long Yr;
	int M;
	int D;
	int h;
	int m;
	double s;

	Ticks = (long far*) TICK_ADDR;
	/* set century for Y2K problem with CMOS clock */
	getdate( &d);
	Century = d.da_year / 100;
	SetDOSToCMOS();

	if( DisplayOpeningMsgs)
	{
		printf( "\nUpdating DOS Time & Date to CMOS Time & Date of ");
		DisplayCMOSTimeDate();
	}

	getdate( &d);
	Yr = (long) d.da_year;
	M = (int) d.da_mon;
	D = (int) d.da_day;
	gettime( &t);
	h = (int) t.ti_hour;
	m = (int) t.ti_min;
	s = ((double) t.ti_sec) + (t.ti_hund / 100.);

	SetStartBiosClockAndSidTime( Yr, M, D, h, m, s, Tz, DST, LongitudeDeg);
}

void SetStartBiosClockAndSidTime( const long Yr, const int M, const int D,
const int h, const int m, const double s, const int Tz, const int DST,
double LongitudeDeg)
{
	/* set starting bios clock tick count */
	StartTicks = *Ticks;
	Days = 0;
	CalcJD( Yr, M, D, Tz, DST, h, m, s);
	CalcSidHr( Yr, M, D, Tz, DST, h, m, s, LongitudeDeg);
	StartSidT = SidT = SidHr/RadToHr;
}

int NewSidT( void)
{
	static long LastTicks;

	/* bios clock ticks... */
	if( *Ticks == LastTicks)
		return No;
	else
	{
		if( *Ticks < LastTicks)
			Days++;
		LastTicks = *Ticks;
		/* calc sidereal time based on bios clock ticks since program start */
		SidT = StartSidT + (LastTicks + Days*ClockTicksDay - StartTicks) /
		RadToClockTick;

		Current.SidT = SidT;
		return Yes;
	}
}

void CalcJD( const long Y, const int M, const int D, const int Tz, const int DST,
const int h, const int m, const double s)
{
	long A;
	double B;

	/* return 1st formula if Gregorian calendar, otherwise 2nd formula for
	Julian calendar: Sky and Telescope, August, 1991, pg 183 */
	if( (Y > 1582) || (Y == 1582 && M > 10) || (Y == 1582 && M == 10 && D > 15))
		A = 367*Y - 7*(Y + (M + 9)/12)/4 - 3*((Y + (M - 9)/7)/100 + 1)/4
		+ 275*M/9 + D + 1721029L;
	else
		A = 367*Y - 7*(Y + 5001 + (M - 9)/7)/4 + 275*M/9 + D + 1729777L;
	/* subtract 12hrs since JD starts at 12noon UT */
	B = (Tz - DST - 12 + h + m/60. + s/3600)/24;
	JD = A + B;
}

void CalcSidHr( const long Y, const int M, const int D, const int Tz, const int DST,
const int h, const int m, const double s, const double LongitudeDeg)
{
	/* JD at 0hrs UT (will be in form of a whole number + 0.5) */
	double JD0HrUT; 
	/* fractional part of JD beyond JD0HrUT */
	double FracDay;
	/* intermediate calculated result */
	double T; 
	/* sidereal time at 0hrs UT */
	double Sid0HrUT; 

	CalcJD( Y, M, D, Tz, DST, h, m, s);

	FracDay = fmod( JD, 1);
	/* FracDay meas. from 0hr UT or < JD > .5 */
	if( FracDay > 0.5)
		FracDay -= 0.5;
	else
		FracDay += 0.5; 
	JD0HrUT = JD - FracDay; 

	/* Astronomical Formulae for Calculators, by Jean Meeus, pg 39 */
	T = (JD0HrUT - 2415020.)/36525.; 
	Sid0HrUT = 6.6460656 + 2400.051262*T + 0.00002581*T*T;
	SidHr = fmod( FracDay*SidRate*24. + Sid0HrUT - LongitudeDeg/15., 24); 
}

void GetHMSH( long TotalHundSec, struct HMSH* V)
{
	long HrHundSec;
	long MinHundSec; 

	if( TotalHundSec < 0)
	{
		TotalHundSec = -TotalHundSec;
		V->Sign = Minus;
	}
	else
		V->Sign = Plus;

	V->Hr = (int) ( TotalHundSec/360000L);
	HrHundSec = (long) V->Hr*360000L;
	V->Min = (int) ((TotalHundSec - HrHundSec)/6000);
	MinHundSec = (long) V->Min*6000;
	V->Sec = (int) ((TotalHundSec - HrHundSec - MinHundSec)/100);
	V->HundSec = (int) (TotalHundSec - HrHundSec - MinHundSec - V->Sec*100);
}

void DisplayHMSH( const struct HMSH V)
{
	printf( "%2d:%02d:%02d.%02d", V.Hr, V.Min, V.Sec, V.HundSec);
}

void StrBufHMSH( const struct HMSH V)
{
	sprintf( StrBuf, "%2d:%02d:%02d.%02d", V.Hr, V.Min, V.Sec, V.HundSec);
}

void DisplayHMST( const struct HMSH V)
{
	printf( "%2d:%02d:%02d.%1d", V.Hr, V.Min, V.Sec, (V.HundSec + 5)/10);
}

void DisplayHMS( const struct HMSH V)
{
	printf( "%2d:%02d:%02d", V.Hr, V.Min, V.Sec);
}

void StrBufHMS( const struct HMSH V)
{
	sprintf( StrBuf, "%2d:%02d:%02d", V.Hr, V.Min, V.Sec);
}

void DisplaySHMS( const struct HMSH V)
{
	char Sign;

	if( V.Sign == Plus)
		Sign = '+';
	else
		Sign = '-';
	printf( "%c%2d:%02d:%02d", Sign, V.Hr, V.Min, V.Sec);
}

void StrBufSHMS( const struct HMSH V)
{
	char Sign;

	if( V.Sign == Plus)
		Sign = '+';
	else
		Sign = '-';
	sprintf( StrBuf, "%c%2d:%02d:%02d", Sign, V.Hr, V.Min, V.Sec);
}

void CalcRadFromHMSH( double* R, struct HMSH V)
{
	*R = (double) V.Hr/RadToHr + (double) V.Min/RadToMin +
	(double) V.Sec/RadToSec + (double) V.HundSec/RadToHundSec;

	if( V.Sign == Minus)
		*R = -*R;
}

void CalcRadFromDMS( double* R, struct DMS V)
{
	*R = (double) V.Deg/RadToDeg + (double) V.Min/RadToArcmin +
	 (double) V.Sec/RadToArcsec;
	if( V.Sign == Minus)
		*R = -*R; 
}

void TestTimes( void)
{
	printf( "\n\n\nTest of astronomical times code, press any key to stop...\n");
	printf( "\nJulian Date %f   Sidereal Time ", JD);
	VidMemXY.X = wherex();
	VidMemXY.Y = wherey();
	while( !KeyStroke)
		if( NewSidT())
		{
			GetHMSH( RadToHundSec*SidT + 0.5, &SidTimeHMSH);
			gotoxy( VidMemXY.X, VidMemXY.Y);
			DisplayHMSH( SidTimeHMSH); 
		}
	getch(); 
	printf( "\nTest of CMOS clock code, press any key to stop...\n");
	VidMemXY.X = wherex();
	VidMemXY.Y = wherey();
	while( !KeyStroke)
	{
		SetDOSToCMOS();
		gotoxy( VidMemXY.X, VidMemXY.Y);
		DisplayCMOSTimeDate();
	}
	getch();
	NewLine;
	ContMsgRoutine();
}

/* coordinates... */

void InitCoord( const Flag DisplayOpeningMsgs)
{
	LoadCurrentAltaz( DisplayOpeningMsgs);
	Current.Ra = 0;
	Current.Dec = 0;
	Current.SidT = SidT;
}

void SaveCurrentAltaz( void)
{
	Output = fopen( CurrentFile, "w");
	if( Output == NULL)
		BadExit( strcat( "Could not open ", CurrentFile));

	fprintf( Output, "Current.Alt %f\n", Current.Alt*RadToDeg);
	fprintf( Output, "Current.Az %f\n", Current.Az*RadToDeg);
	fclose( Output);
}

void LoadCurrentAltaz( const Flag DisplayOpeningMsgs)
{
	Input = fopen( CurrentFile, "r");
	if( Input == NULL)
	{
		if( DisplayOpeningMsgs)
			printf( "\nCould not open %s", CurrentFile); 
		Current.Alt = Current.Az = 0;
	}
	else
	{
		fscanf( Input, "%s", Name);
		while( !feof( Input))
		{
			if( (strncmpi( Name, "Current.Alt", sizeof( Name))) == 0)
			{
				ReadDouble( Input, &Current.Alt); 
				Current.Alt /= RadToDeg;
			}
			else if( (strncmpi( Name, "Current.Az", sizeof( Name))) == 0)
			{
				ReadDouble( Input, &Current.Az);
				Current.Az /= RadToDeg;
			}
			fscanf( Input, "%s", Name);
		}
		fclose( Input);
	}
}

void ValidRa( struct Position* Pos)
{
	while( Pos->Ra > OneRev)
		Pos->Ra -= OneRev;
	while( Pos->Ra < 0)
		Pos->Ra += OneRev;
}

void ValidHA( struct Position* Pos)
{
	while( Pos->HA > HalfRev)
		Pos->HA -= OneRev;
	while( Pos->HA < -HalfRev)
		Pos->HA += OneRev;
}

void ValidDec( struct Position* Pos)
{
	if( Pos->Dec > QtrRev)
		Pos->Dec = OneRev;
	else if( Pos->Dec < -QtrRev)
		Pos->Dec = -OneRev;
}

void ValidAlt( struct Position* Pos)
{
	while( Pos->Alt > HalfRev)
		Pos->Alt -= OneRev;
	while( Pos->Alt < -HalfRev)
		Pos->Alt += OneRev;
}

void ValidAz( struct Position* Pos)
{
	while( Pos->Az > OneRev)
		Pos->Az -= OneRev;
	while( Pos->Az < 0)
		Pos->Az += OneRev;
}

void SetCoord( struct Position* Pos, const double RaDeg, const double DecDeg,
const double AltDeg, const double AzDeg, const double SidTDeg)
{
	Pos->Ra = RaDeg/RadToDeg;
	Pos->Dec = DecDeg/RadToDeg;
	Pos->Alt = AltDeg/RadToDeg;
	Pos->Az = AzDeg/RadToDeg;
	Pos->SidT = SidTDeg/RadToDeg;
}

void ShowCoord( struct Position* Pos)
{
	printf( "\ncoordinates in degrees are:\n"); 
	printf( " Ra: %7.3f", Pos->Ra * RadToDeg);
	printf( "  Dec: %7.3f", Pos->Dec * RadToDeg);
	printf( "  Alt: %7.3f", Pos->Alt * RadToDeg);
	printf( "  Az: %7.3f", Pos->Az * RadToDeg);
	printf( "  SidT: %7.3f", Pos->SidT * RadToDeg);
}

void GetDMS( long TotalSec, struct DMS* V)
{
	if( TotalSec < 0)
	{
		TotalSec = -TotalSec;
		V->Sign = Minus;
	}
	else
		V->Sign = Plus;
	V->Deg = (int) (TotalSec/3600);
	V->Min = (int) ((TotalSec - (long) (V->Deg) * 3600)/60);
	V->Sec = (int) (TotalSec - V->Deg * 3600 - V->Min * 60);
}

void DisplayDMS( const struct DMS D)
{
	char Sign;

	if( D.Sign)
		Sign = '+';
	else
		Sign = '-';
	printf( "%c%2d:%02d:%02d", Sign, D.Deg, D.Min, D.Sec);
}

void StrBufDMS( const struct DMS D)
{
	char Sign;

	if( D.Sign)
		Sign = '+';
	else
		Sign = '-';
	sprintf( StrBuf, "%c%2d:%02d:%02d", Sign, D.Deg, D.Min, D.Sec);
}

void VidMemDeg( const double Deg)
{
	sprintf( StrBuf, "%7.3f", Deg * RadToDeg);
	WriteStrBufToScreen();
}

void VidMemRaHMS( struct Position* Pos)
{
	GetHMSH( RadToHundSec*Pos->Ra + 0.5, &Pos->RaHMSH); 
	StrBufHMS( Pos->RaHMSH); 
	WriteStrBufToScreen(); 
}

void VidMemRaHMSH( struct Position* Pos)
{
	GetHMSH( RadToHundSec*Pos->Ra + 0.5, &Pos->RaHMSH);
	StrBufHMSH( Pos->RaHMSH);
	WriteStrBufToScreen();
}

void VidMemHAHMS( struct Position* Pos)
{
	GetHMSH( RadToHundSec*Pos->HA + 0.5, &Pos->HAHMSH);
	StrBufSHMS( Pos->HAHMSH);
	WriteStrBufToScreen();
}

void VidMemDecDMS( struct Position* Pos)
{
	GetDMS( RadToArcsec*Pos->Dec + 0.5, &Pos->DecDMS);
	StrBufDMS( Pos->DecDMS);
	WriteStrBufToScreen(); 
}

void VidMemSidT( struct Position* Pos)
{
	GetHMSH( RadToHundSec*Pos->SidT + 0.5, &Pos->SidTimeHMSH);
	StrBufHMS( Pos->SidTimeHMSH);
	WriteStrBufToScreen();
}

/* parallel port */

/* Normally, a PC can have up to 3 parallel printer ports - LPT1, LPT2 & LPT3.
Their (16-bit) base addresses in the processor's I/O space are loaded into
memory when the machine is booted, starting at address 408 Hex.

A well-written program requiring direct access to any of these ports should
endeavour to find out which are present and where at run-time (rather than use
constant declarations)

Due to 80x86 processors being " little-endian", the addresses are stored as
follows:

408 409  40a 40b  40c 40d
LPT1     LPT2     LPT3
low/high low/high low/high
byte     byte     byte

For example, the following values -

408 409 40a 40b 40c 40d
78  03  78  02  00  00

mean that LPT1 is at 378 Hex, LPT2 is at 278 Hex, and LPT3 is not present.

8 bits out:
base address portid lpt1 = 0x378 (decimal 888), lpt2 = 0x278 (decimal 632),
monochrome video card = 0x3BC (decimal 956);
25 - pin connector pins 2 (least significant) through 9 (most significant),
logical low in produces logical low out;

5 bits in:
base address + 1, portid 0x379 (or try 0x279 or 0x3BD):

	8		16		32		64		128	bit
	H		H		H		H		H		in
	15		13		12		10		11		25 pin connector pin #
	L		H		H		H		L		result, eg, inverted for bit 128;

	module logic rectifies the inverted bit;

4 bits in or out:
base address + 2, portid 0x37A (or try 0x27A or 0x3BE):

	1       2       4       8    		bit
	H       H       H       H        in or out
	1       14      16      17       25 pin connector pin #
	L       L       H       L        result, eg, inverted for all bits
												except for bit 4;

	module logic rectifies the inverted bits;

remaining pin connections:
25 pin connector pins 18 through 25 are grounds; */

void InitPPort( void)
{
	int HoldPPortAddr = PPortAddr;

   /* if PPortAddr <=3, treat it as a lpt num */
	if( PPortAddr <= 3)
		if( !(PPortAddr = GetPPortAddr( PPortAddr)))
		{
			sprintf( StrBuf, "Bad lpt:%01d", HoldPPortAddr);
			BadExit( StrBuf);
		}
	PPortAddrOutByte = PPortAddr;
	PPortAddrInNibble = PPortAddr + 1;
	PPortAddrInOutNibble = PPortAddr + 2;
	OutByteValue = Off;
	OutByte();
	BiDirOutNibbleValue = Off;
	BiDirOutNibble();
}

unsigned GetPPortAddr( int lptnum)
{
	/* make a far pointer with segment 0x40 and offset 0x008+...
	then return its value */
	return *(unsigned far *)(MK_FP( 0x40, 0x008 + (lptnum-1)*2));
}

void DisplayLpts (void)
{
	int x;

	printf( "\n\n\ndisplaying lpt ports:");
	for( x=1; x<=3; x++)
		printf( "\nlpt%1d: 0x%04x", x, GetPPortAddr( x));
	printf( "\n\n");
}

void OutByte( void)
{
	outportb( PPortAddrOutByte, OutByteValue);
}

void BiDirOutNibble( void)
{
	outportb( PPortAddrInOutNibble, BiDirOutNibbleValue);
}

Byte InNibble( void)
{
	/* 4 bits in: parallel port lines 13, 12, 10, 11 using bits 16, 32, 64,
	128 */
	return (inportb( PPortAddrInNibble)&240) ^ 128;

	/* 5 bits in: parallel port lines 15, 13, 12, 10, 11 using bits 8, 16, 32,
	64, 128 */
	/* return (inportb( PPortAddrInNibble)&248) ^ 136; */
}

Byte BiDirInNibble( void)
{
	return (inportb( PPortAddrInOutNibble)&15) ^ 11;
}

void TestPPort( void)
{
	int Input; 

	printf( "\n\n\Test of parallel port code:\n");
	DisplayLpts();
	printf( "'h' for logical high, 'l' for logical low, 'q' to quit.\n");
	Input = ' '; 
	while( Input != 'q')
	{
		Input = getch();
		if( Input == 'h' || Input == 'H')
		{
			printf( "outputting logical high...\n"); 
			outportb( PPortAddrOutByte, PortOn);
		}
		else if( Input == 'l' || Input == 'L')
		{
			printf( "outputting logical low...\n");
			outportb( PPortAddrOutByte, PortOff);
		}
	}
	outportb( PPortAddrOutByte, PortOff);
	NewLine;
	ContMsgRoutine();
}

/* if need to move to alt = 0, instead move to alt = 0.5,
if measured alt from object = 0.5, alt to use in calculations = 0;
refraction handled by routines that translate between scope's
position (AccumAMs) and sky altitude (Current.Alt) */

void InitRefract( void)
{
	Refract = 0;

	/* set values here because formula needed to calc value */
	R1[0][0] = 0/RadToDeg;
	R1[0][1] = 0/RadToArcmin;
	R1[1][0] = 60/RadToDeg;
	R1[1][1] = 1.7/RadToArcmin;
	R1[2][0] = 80/RadToDeg;
	R1[2][1] = 5.5/RadToArcmin;
	R1[3][0] = 84/RadToDeg;
	R1[3][1] = 8.6/RadToArcmin;
	R1[4][0] = 88/RadToDeg;
	R1[4][1] = 18.1/RadToArcmin;
	R1[5][0] = 90/RadToDeg;
	R1[5][1] = 34.5/RadToArcmin;

	R2[0][0] = 0/RadToDeg;
	R2[0][1] = 0/RadToArcmin;
	R2[1][0] = 60/RadToDeg - 1.7/RadToArcmin;
	R2[1][1] = 1.7/RadToArcmin;
	R2[2][0] = 80/RadToDeg - 5.5/RadToArcmin;
	R2[2][1] = 5.5/RadToArcmin;
	R2[3][0] = 84/RadToDeg - 8.6/RadToArcmin;
	R2[3][1] = 8.6/RadToArcmin;
	R2[4][0] = 88/RadToDeg - 18.1/RadToArcmin;
	R2[4][1] = 18.1/RadToArcmin;
	R2[5][0] = 90/RadToDeg - 34.5/RadToArcmin;
	R2[5][1] = 34.5/RadToArcmin;
};

/* this function calcs refraction to add to altitude */
void CalcRefractScopeToSky( const double Alt)
{
	int Ix;
	double ZAng;

	ZAng = M_PI/2 - Alt; 
	if( ZAng < 0)
		ZAng = -ZAng;
	for( Ix = 0; ZAng > R1[Ix][0] && Ix < MaxRefractIx; Ix++)
		;
	Refract = R1[Ix-1][1] + (ZAng - R1[Ix-1][0])*( R1[Ix][1] - R1[Ix-1][1])
	/( R1[Ix][0] - R1[Ix-1][0]);
}

/* this function calcs refraction to remove from altitude */
void CalcRefractSkyToScope( const double Alt)
{
	int Ix;
	double ZAng;

	ZAng = M_PI/2 - Alt;
	if( ZAng < 0)
		ZAng = -ZAng;
	for( Ix = 0; ZAng > R2[Ix][0] && Ix < MaxRefractIx; Ix++)
		;
	Refract = R2[Ix-1][1] + (ZAng - R2[Ix-1][0])*( R2[Ix][1] - R2[Ix-1][1])
	/( R2[Ix][0] - R2[Ix-1][0]);
}

/* egavga routines */

void InitGraphics( void)
{
	int gdriver;
	int gmode;
	int errorcode;


	gettext( 1, 1, MaxX, MaxY, WinBuffer);
	clrscr();

	/* request autodetection */
	gdriver = DETECT;

	/* create egavga.obj file by changing to \bc45\bgi then
	execute bgiobj.exe egavga which creates the egavga.obj file
	copy the egavga.obj file to the working subdirectory
	add graphics.h to source file
	add \bc45\lib\graphics.lib to project
	add egavga.obj to project */

	if( registerbgidriver( EGAVGA_driver) < 0)
		BadExit( "could not register egavga driver");

	/* init graphics and local vars */
	initgraph( &gdriver, &gmode, "");

	/* read result of initialization */
	errorcode = graphresult();
	if( errorcode != grOk)
	{
		BadExit( strcat( "initgraph error: ", grapherrormsg( errorcode)));
		printf( "Press any key to halt:");
		getch();
		/* terminate with err code */
		exit( 1);
	}
	maxx = getmaxx();
	maxy = getmaxy();

	/* putpixel( x, y, color); */
}

void CloseGraphics( void)
{
	closegraph();
	clrscr();
	window( 1, 1, MaxX, MaxY);
	puttext( 1, 1, MaxX, MaxY, WinBuffer);
	_setcursortype( _NORMALCURSOR);
}

/* mouse functions */

void InitMouse( void)
{
	ResetMouse();
}

void CallMouse( void)
{
	union REGS inregs, outregs;

	inregs.x.ax = inax;
	inregs.x.bx = inbx;
	inregs.x.cx = incx;
	inregs.x.dx = indx;

	int86( MOUSE_INTERRUPT, &inregs, &outregs);

	outax = outregs.x.ax;
	outbx = outregs.x.bx;
	outcx = outregs.x.cx;
	outdx = outregs.x.dx;
}

void GetDefaultMouseSensitivity( void)
{
	inax = GET_MOUSE_SENSITIVITY;
	CallMouse();

	HorizMickeySensitivity = outbx;
	VertMickeySensitivity = outcx;
	ThresholdDblSpeed = outdx;
}

void DecodeMousePosition( void)
{
	MouseXGraph = outcx;
	MouseYGraph = outdx;
	MouseXText = MouseXGraph/8 + 1;
	MouseYText = MouseYGraph/8 + 1;
}

void ResetMouse( void)
{
	inax = RESET_MOUSE;
	CallMouse();
	if(outax != SUCCESSFULL_MOUSE_RESET)
		BadExit( "could not find mouse driver");
}

void LowMouseSensitivity( void)
{
	GetDefaultMouseSensitivity();

	inax = SET_MOUSE_SENSITIVITY;
	inbx = 4;
	incx = 4;
	indx = 64;
	CallMouse();
}

void ResetMouseSensitivity( void)
{
	inax = SET_MOUSE_SENSITIVITY;
	inbx = HorizMickeySensitivity;
	incx = VertMickeySensitivity;
	indx = ThresholdDblSpeed;
	CallMouse();
}

void DisplayMouse( void)
{
	inax = DISPLAY_MOUSE;
	CallMouse();
}

void HideMouse( void)
{
	inax = HIDE_MOUSE;
	CallMouse();
}

void GetMousePosition( void)
{
	inax = GET_MOUSE_POSITION;
	CallMouse();
	DecodeMousePosition();
}

void GetMousePositionRelative( void)
{
	inax = GET_MOUSE_POSITION_RELATIVE;
	CallMouse();
	MouseXMickeyRelative = outcx;
	MouseYMickeyRelative = outdx;
}

void SetMousePosition(int Horiz,int Vert)
{
	inax = SET_MOUSE_POSITION;
	incx = Horiz;
	indx = Vert;
	CallMouse();
}

void CenterMouseCursor( void)
{
	SetMousePosition( MouseMidXText, MouseMidYText);
}

int MouseLeftButtonPress( void)
{
	inax = GET_MOUSE_PRESS_INFO;
	inbx = LEFT_BUTTON;
	CallMouse();
	// get position at last press
	if( outbx)
	{
		DecodeMousePosition();
		return Yes;
	}
	else
		return No;
}

int MouseRightButtonPress( void)
{
	inax = GET_MOUSE_PRESS_INFO;
	inbx = RIGHT_BUTTON;
	CallMouse();
	// get position at last press
	if( outbx)
	{
		DecodeMousePosition();
		return Yes;
	}
	else
		return No;
}

int MouseLeftButtonReleased( void)
{
	inax = GET_MOUSE_RELEASE_INFO;
	inbx = LEFT_BUTTON;
	CallMouse();
	// get position at last release
	if( outbx)
	{
		DecodeMousePosition();
		return Yes;
	}
	else
		return No;
}

int MouseRightButtonReleased( void)
{
	inax = GET_MOUSE_RELEASE_INFO;
	inbx = RIGHT_BUTTON;
	CallMouse();
	// get position at last release
	if( outbx)
	{
		DecodeMousePosition();
		return Yes;
	}
	else
		return No;
}

void TestMouse( void)
{
	clrscr();
	printf( "Test of mouse module: press any key to exit...\n");
	while( !KeyStroke)
	{
		DisplayMouse();
		if(MouseLeftButtonPress())
			printf( "\nleft button pressed...");
		else if(MouseRightButtonPress())
			printf( "\nright button pressed...");
		else
		{
			GetMousePositionRelative();
			printf( "\nrelative mouse position: %d %d", MouseXMickeyRelative,
			MouseYMickeyRelative);
			delay( 1000);
		}
	}
	getch();
}

